[BITS 16]
[ORG 0x0100]

[SEGMENT .text]

	mov ah,00h		; selecionar modo de vdeo
	mov al,12h		; modo grfico
	int 10h			; chama o servio de vdeo da BIOS
	
	mov cx,[POSX]		; Se assegura de que a primeira cruz
	mov dx,[POSY]		; ser pintada no centro
	call Pinta_Cruz		; Pinta uma Cruz (alvo)
	
Movimenta:
	mov ah,10h		; Espera at vir uma entrada pelo teclado
	int 16h			; e coloca em ax

	cmp ah,4Bh		; se foi pressionado seta para esquerda,
	je TesteEsquerda	; vai para TesteEsquerda
	cmp ah,4Dh		; se foi pressionado seta para direita,
	je TesteDireita		; vai para TesteDireita
	cmp ah,50h		; se foi pressionado seta para cima,
	je TesteCima		; vai para TesteCima
	cmp ah,48h		; se foi pressionado seta para baixo,
	je TesteBaixo		; vai para TesteBaixo

	jmp Movimenta		; Loop
	
; --------------------------------------------------------------------------- ;

	;; Rotinas idnticas para testar se o objeto no est ultrapassando
	;; os limites da tela (640x480)
	
TesteEsquerda:
	mov ax,[POSX]
	cmp ax,10
	je Movimenta
	jmp Esquerda	

TesteDireita:
	mov ax,[POSX]
	cmp ax,630
	je Movimenta
	jmp Direita	

TesteCima:
	mov ax,[POSY]
	cmp ax,470
	je Movimenta
	jmp Cima
	
TesteBaixo:
	mov ax,[POSY]
	cmp ax,10
	je Movimenta
	jmp Baixo

	;; Fim das rotinas de teste de ultrapassagem da tela

; --------------------------------------------------------------------------- ;

	;; Rotinas para pintar/apagar o objeto Cruz da tela
	
Pinta_Cruz:
	mov al,4		; color 4 - red
	call Cruz		; chama a rotina Cruz
	ret
	
Apaga_Cruz:
	mov al,0		; color 0 - black
	call Cruz		; chama a rotina Cruz
	ret
	
Pinta:
	push ax			; salva ax pois ele ser mudado
	mov ah,0Ch	 	; function 0Ch - Write
	int 10h			; call BIOS Video Service
	pop ax 			; retorna o ax salvo
	ret
		
Cruz:
	mov cx,[POSX]		; Assegura que cx e dx estaum
	mov dx,[POSY]		; nas posies atuais.
	mov bx,21		;   Desenha
	sub cx,10		;      a
	call Reta1		;    reta
	mov cx,[POSX]		; horizontal
	mov bx,21		;  Desenha
	sub dx,10		;     a
	call Reta2		;    reta
	mov dx,[POSY]		;  vertical
	
	ret

Return:
	ret

Reta1:
	call Pinta		; pinta o ponto atual
	inc cx			; anda 1 pixel para a direita
	dec bx			; decrementa o contador
	cmp bx,0		; se o contador eh zero,
	je Return		; retorna para a funcao q a chamou
	jmp Reta1		; loop

Reta2:
	call Pinta		; pinta o ponto atual
	inc dx			; anda um pixel para cima
	dec bx			; decrementa o contador
	cmp bx,0		; se o contador eh zero,
	je Return		; retorna para a funcao q a chamou
	jmp Reta2		; loop

	;; Fim das rotinas para desenhar/apagar a cruz na tela

; --------------------------------------------------------------------------- ;

	;; Rotinas para escrever a Cruz quando elas saum movimentadas

Esquerda:	
	call Apaga_Cruz		; Apaga a cruz nas coordenadas atuais
	mov cx,[POSX]		; x position
	sub cx,5		; anda para a esquerda
	mov [POSX],cx		; salva a nova posio
	mov dx,[POSY]		; y position
	call Pinta_Cruz		; chama a rotina para pintar nas coordenadas escolhidas
	jmp Movimenta		; volta para a rotina de Movimentacao

Direita:
	call Apaga_Cruz		; Apaga a cruz nas coordenadas atuais
	mov cx,[POSX]		; x position
	add cx,5		; anda para a direita
	mov [POSX],cx		; Salva a posicao
	mov dx,[POSY]		; y position
	call Pinta_Cruz		; chama a rotina para pintar nas coordenadas escolhidas
	jmp Movimenta		; volta para a rotina de Movimentacao

Cima:
	call Apaga_Cruz		; Apaga a cruz nas coordenadas atuais
	mov cx,[POSX]		; x position
	mov dx,[POSY]		; y position
	add dx,5		; Anda para cima
	mov [POSY],dx		; Salva a posio
	call Pinta_Cruz		; chama a rotina para pintar nas coordenadas escolhidas
	jmp Movimenta		; volta para a rotina de Movimentacao

Baixo:
	call Apaga_Cruz		; Apaga a cruz nas coordenadas atuais
	mov cx,[POSX]		; x position
	mov dx,[POSY]		; y position
	sub dx,5		; anda para baixo
	mov [POSY],dx		; salva posio
	call Pinta_Cruz		; chama a rotina para pintar nas coordenadas escolhidas
	jmp Movimenta		; volta para a rotina de Movimentacao

	;; Fim
; --------------------------------------------------------------------------- ;
	
[SEGMENT .data]
	POSX dw 320
	POSY dw 240

; --------------------------------------------------------------------------- ;